// File _COARRAY.h
//           
//////////////////////////////////////////////////////////////////////////////
#ifndef  _COARRAY__
#define  _COARRAY__

#include "_WIN.h"

//////////////////////////////////////////////////////////////////////////////
#define COARRAYSEG 256 //   -.

union tcounit { void *P;
                struct { void *Pointer; //   ;  
                         WCHAR *Name;   //   -  .  
                       };
              };  

typedef tcounit tcounit_arr[256];                  
             
class BaseCOARRAY                               //   
{ public:
  int First,Last,Top;  //  , , , ( )
  int AutoCreate;      //     ,   ,       
                       //   = Yes; 
  int Nothing;         //   "" -    .   = -1                    
  tcounit_arr *ARRAY;  //      
  tcounit *UNIT;       //             
  int Number;          //        
  void **COBJECT;      //     
  int *nCOBJECT;       //      
  WCHAR **nameCOBJECT; //      
      
  void *(*fNEW)();         //       
  void (*fDELETE)(void *p); //      

  BaseCOARRAY();
  BaseCOARRAY(void **co, int *nco, WCHAR **nameco, void *(*fnew)(), void (*fdelete)(void*), int nothing = -1);                          
  ~BaseCOARRAY(); 

  int Ready();             //     
  void Init(void **co, int *nco, WCHAR **nameco, void *(*fnew)(), void (*fdelete)(void*), int nothing = -1);
                           //      . 
  int Create(int n, WCHAR *name = NULL);  //     ,  , - ,
                                          //        -    .
                                          //  ,  .    
  int Count();
  void Delete(int n);               // 
  int DeleteName(WCHAR *name);      //   ,   ,  -1   .
  int Present(int n);               //  
  int PresentName(WCHAR *name);
  int NameNumber(WCHAR *name);      //     : -1   
  int Add(WCHAR *name = NULL);      //   ,  .
  void *Get(int n);                 //        n
  void *GetName(WCHAR *name);       // ...   name
  int Current(int n);               //  
  int CurrentName(WCHAR *name);
  int Start();      //     
  int Next();       //   ,  ,  0    .
                    //   if (OBJ.Start())
                    //   do { COBJ->Conv = ...
                    //      } while (OBJ.Next());
  void Done();      // ,   .
      
  protected:
  int Hole;
      
  void AutoSize(int n);
  int GetFreeNum();
  int CurrentNoChk();
};

//////////////////////////////////////////////////////////////////////////////
#endif
