// File _TYPE.h;
//////////////////////////////////////////////////////////////////////////////
#ifndef _MEM__
#define _MEM__
//////////////////////////////////////////////////////////////////////////////
#include "_TYPE.h"
//////////////////////////////////////////////////////////////////////////////
inline void dwMemSet(void *dest, unsigned v, unsigned count)
{
  _asm { movd xmm1,v
         pshufd xmm1,xmm1,0
         mov ebx,dest    
         mov ecx,count         
         mov edx,ecx        
         and ecx,0xfffffff0 
         jz _rem            
         add ecx,ebx        
        _loop: 
         movups [ebx],xmm1  
         add ebx,16
         cmp ecx,ebx
         jne _loop 
        _rem:
         and edx,0x0f       
         jz _ex             
         add edx,ebx        
        _loopr:
         movd [ebx],xmm1
         add ebx,4
         cmp edx,ebx
         jne _loopr
        _ex: 
         emms
       };  
};

inline void dwMemSetA16(void *dest, unsigned v, unsigned count)
{
  _asm { movd xmm1,v
         pshufd xmm1,xmm1,0
         mov ebx,dest    
         mov ecx,count         
         and ecx,0xfffffff0 
         jz _ex            
         add ecx,ebx        
        _loop: 
         movaps [ebx],xmm1  
         add ebx,16
         cmp ecx,ebx
         jne _loop 
        _ex:
         emms
       };  
};

//////////////////////////////////////////////////////////////////////////////
inline void MemMoveA16(void *dest, void *src, unsigned sz) //      16-     16- (128-  ) 
{
  _asm { mov ebx,src
         mov edx,dest
         mov ecx,sz
         add ecx,ebx 
        _loop:
         movaps xmm0,[ebx]
         movaps [edx],xmm0
         add ebx,16
         add edx,16
         cmp ebx,ecx
         jne _loop  
         emms
       }; 
};

//////////////////////////////////////////////////////////////////////////////

#endif
