//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "_WIN.h"
#include "_DRAW_2D.h"

//////////////////////////////////////////////////////////////////////////////
void PreviewScreenSaverDRAW()
{
  InitCommonResource();
  GDIrun();
  Graphics *pGraphics = new Graphics(hBaseDC);
  FillRect(hBaseDC,&ScreenSaverRECT,(HBRUSH)GetStockObject(BLACK_BRUSH));
  Bitmap* pBitmap = new Bitmap(hmCommonResource, L"PreviewScr");
  pGraphics->DrawImage(pBitmap,((ScreenSaverRECT.right - ScreenSaverRECT.left) - 152) / 2,
                               ((ScreenSaverRECT.bottom - ScreenSaverRECT.top) - 112) / 2);
  delete pBitmap;
  delete pGraphics;
  GDIstop();
};
//////////////////////////////////////////////////////////////////////////////
void ScreenLoadDRAW()
{
  InitCommonResource();
  dwRGB c = VS_CColor; VS_CColor = 0; DrawClear(); 

  BaseSPR *screenload = new BaseSPR(L"LoadScr");
  screenload->Place(0, 0, modePUT + fromCC); screenload->Draw();
  int y = screenload->Region.YL;
  delete screenload;
  
  screenload = new BaseSPR(L"InfoScr");
  screenload->Place(0, 12, modePUT + fromDC); screenload->Draw();
  delete screenload;

  SPRforceColor = RGBis(170,170,170);
  screenload = new BaseSPR(L"UrlScr");
  screenload->pixSize = 1; screenload->pixSpace = 1;
  screenload->Place(0, y + 16, modePUT + fromUC); screenload->Draw();
  delete screenload;

  DrawPaint(); 
  VS_CColor = c;
};

//////////////////////////////////////////////////////////////////////////////
int cgInit()
{
  ScreenSaverMessage = L"\nExit - key Esc  \n\nHelp - key F1  \n\n";
  ScreenSaverTitle = L"    Coding Gene";
  ScreenSaverPreviewText = L"C o d i n g  G e n e";

  EScreenSaverPreviewDraw = PreviewScreenSaverDRAW;
  EScreenLoadDraw = ScreenLoadDRAW;  
  return 1;
};

int cgInited = cgInit(); 
//////////////////////////////////////////////////////////////////////////////
